import express from 'express';
import { ApiSpec, Method as HttpMethod } from '@api-ts/io-ts-http';
import { RouteHandler } from './request';
import { ResponseEncoder } from './response';
export { middlewareFn, MiddlewareChain, MiddlewareChainOutput } from './middleware';
export type { ResponseEncoder, KeyedResponseType } from './response';
export { routeHandler, ServiceFunction } from './request';
declare type CreateRouterProps<Spec extends ApiSpec> = {
    spec: Spec;
    routeHandlers: {
        [ApiName in keyof Spec]: {
            [Method in keyof Spec[ApiName] & HttpMethod]: RouteHandler<NonNullable<Spec[ApiName][Method]>>;
        };
    };
    encoder?: ResponseEncoder;
};
export declare function routerForApiSpec<Spec extends ApiSpec>({ spec, routeHandlers, encoder, }: CreateRouterProps<Spec>): import("@api-ts/typed-express-router").WrappedRouter<Spec>;
export declare const createServer: <Spec extends ApiSpec>(spec: Spec, configureExpressApplication: (app: express.Application) => { [ApiName in keyof Spec]: { [Method in keyof Spec[ApiName] & ("get" | "post" | "put" | "delete" | "patch")]: RouteHandler<NonNullable<Spec[ApiName][Method]>>; }; }) => import("express-serve-static-core").Express;
//# sourceMappingURL=index.d.ts.map