import * as express from 'express';
export declare const MiddlewareBrand: unique symbol;
export declare type MiddlewareBrand = typeof MiddlewareBrand;
export declare type MiddlewareFn<T extends {}> = (req: express.Request, res: express.Response) => Promise<T>;
export declare type MiddlewareHandler<T extends {} = {}> = {
    (req: express.Request, res: express.Response, next: express.NextFunction): void;
    [MiddlewareBrand]: T;
};
export declare type MiddlewareRequestHandler = express.RequestHandler | MiddlewareHandler;
declare type MiddlewareOutput<T extends MiddlewareRequestHandler> = T extends {
    [MiddlewareBrand]: infer R;
} ? R : {};
export declare function middlewareFn<T extends {}>(fn: MiddlewareFn<T>): MiddlewareHandler<T>;
declare type MiddlewareResult<Input extends {}, T> = T extends MiddlewareRequestHandler ? Omit<Input, keyof MiddlewareOutput<T>> & MiddlewareOutput<T> : never;
export declare type MiddlewareChain = [] | [MiddlewareRequestHandler] | [MiddlewareRequestHandler, MiddlewareRequestHandler] | [MiddlewareRequestHandler, MiddlewareRequestHandler, MiddlewareRequestHandler] | [
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler
] | [
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler
] | [
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler
] | [
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler,
    MiddlewareRequestHandler
];
export declare type MiddlewareChainOutput<Input, Chain extends MiddlewareChain> = Chain extends [] ? Input : Chain extends [infer A] ? MiddlewareResult<Input, A> : Chain extends [infer A, infer B] ? MiddlewareResult<MiddlewareResult<Input, A>, B> : Chain extends [infer A, infer B, infer C] ? MiddlewareResult<MiddlewareResult<MiddlewareResult<Input, A>, B>, C> : Chain extends [infer A, infer B, infer C, infer D] ? MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<Input, A>, B>, C>, D> : Chain extends [infer A, infer B, infer C, infer D, infer E] ? MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<Input, A>, B>, C>, D>, E> : Chain extends [infer A, infer B, infer C, infer D, infer E, infer F] ? MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<Input, A>, B>, C>, D>, E>, F> : Chain extends [
    infer A,
    infer B,
    infer C,
    infer D,
    infer E,
    infer F,
    infer G
] ? MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<MiddlewareResult<Input, A>, B>, C>, D>, E>, F>, G> : never;
export declare function runMiddlewareChain<Input extends {}, Chain extends MiddlewareChain>(input: Input, chain: Chain, req: express.Request, res: express.Response): Promise<MiddlewareChainOutput<Input, Chain>>;
export declare function runMiddlewareChainIgnoringResults<Input, Chain extends MiddlewareChain>(input: Input, chain: Chain, req: express.Request, res: express.Response): Promise<Input>;
export {};
//# sourceMappingURL=middleware.d.ts.map