"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runMiddlewareChainIgnoringResults = exports.runMiddlewareChain = exports.middlewareFn = exports.MiddlewareBrand = void 0;
exports.MiddlewareBrand = Symbol();
function middlewareFn(fn) {
    const result = (req, res, next) => {
        fn(req, res)
            .then((result) => next(undefined, result))
            .catch((err) => next(err));
    };
    return result;
}
exports.middlewareFn = middlewareFn;
async function runMiddlewareChain(input, chain, req, res) {
    let result = input;
    for (const middleware of chain) {
        const middlewareResult = await new Promise((resolve, reject) => {
            const next = (value, middlewareResult) => {
                if (value !== undefined) {
                    reject(value);
                }
                else if (middlewareResult !== undefined) {
                    resolve(middlewareResult);
                }
                else {
                    resolve({});
                }
            };
            try {
                middleware(req, res, next);
            }
            catch (err) {
                reject(err);
            }
        });
        result = { ...result, ...middlewareResult };
    }
    return result;
}
exports.runMiddlewareChain = runMiddlewareChain;
async function runMiddlewareChainIgnoringResults(input, chain, req, res) {
    for (const middleware of chain) {
        await new Promise((resolve, reject) => {
            try {
                middleware(req, res, resolve);
            }
            catch (err) {
                reject(err);
            }
        });
    }
    return input;
}
exports.runMiddlewareChainIgnoringResults = runMiddlewareChainIgnoringResults;
//# sourceMappingURL=middleware.js.map