"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleRequest = exports.onEncodeError = exports.onDecodeError = exports.getMiddleware = exports.getServiceFunction = exports.routeHandler = void 0;
const PathReporter = __importStar(require("io-ts/lib/PathReporter"));
const middleware_1 = require("./middleware");
function routeHandler({ middleware = [], handler, }) {
    return { middleware, handler, [middleware_1.MiddlewareBrand]: true };
}
exports.routeHandler = routeHandler;
const getServiceFunction = (routeHandler) => 'handler' in routeHandler ? routeHandler.handler : routeHandler;
exports.getServiceFunction = getServiceFunction;
const getMiddleware = (routeHandler) => ('middleware' in routeHandler ? routeHandler.middleware : []);
exports.getMiddleware = getMiddleware;
const createNamedFunction = (name, fn) => Object.defineProperty(fn, 'name', { value: name });
const onDecodeError = (errs, _req, res) => {
    const validationErrors = PathReporter.failure(errs);
    const validationErrorMessage = validationErrors.join('\n');
    res.writeHead(400, { 'Content-Type': 'application/json' });
    res.write(JSON.stringify({ error: validationErrorMessage }));
    res.end();
};
exports.onDecodeError = onDecodeError;
const onEncodeError = (err, _req, res) => {
    console.warn('Error in route handler:', err);
    res.status(500).end();
};
exports.onEncodeError = onEncodeError;
const handleRequest = (apiName, httpRoute, handler, responseEncoder) => {
    return createNamedFunction('decodeRequestAndEncodeResponse' + httpRoute.method + apiName, async (req, res, next) => {
        try {
            const handlerParams = middleware_1.MiddlewareBrand in handler
                ? await (0, middleware_1.runMiddlewareChain)(req.decoded, (0, exports.getMiddleware)(handler), req, res)
                : await (0, middleware_1.runMiddlewareChainIgnoringResults)(req.decoded, (0, exports.getMiddleware)(handler), req, res);
            const serviceFn = (0, exports.getServiceFunction)(handler);
            const response = await serviceFn(handlerParams);
            responseEncoder(httpRoute, response)(req, res, next);
        }
        catch (err) {
            if (!res.statusCode) {
                res.status(500);
            }
            res.end();
            next();
            return;
        }
    });
};
exports.handleRequest = handleRequest;
//# sourceMappingURL=request.js.map