import express from 'express';
import * as t from 'io-ts';
import { HttpRoute, HttpToKeyStatus, ResponseType } from '@api-ts/io-ts-http';
export declare type KeyedResponseType<R extends HttpRoute> = {
    [Key in keyof R['response'] & keyof HttpToKeyStatus]: {
        type: HttpToKeyStatus[Key];
        payload: t.TypeOf<R['response'][Key]>;
    };
}[keyof R['response'] & keyof HttpToKeyStatus];
export declare type ResponseEncoder = (route: HttpRoute, serviceFnResponse: ResponseType<HttpRoute>) => express.RequestHandler;
export declare const defaultResponseEncoder: ResponseEncoder;
//# sourceMappingURL=response.d.ts.map